
; Packages for Pseudoscheme.

; These DEFPACKAGE forms are totally redundant with IN-PACKAGE and
; EXPORT forms elsewhere in the system, but it might help some buggy
; Common Lisp implementations to better cope with the package setup.

(defpackage "SCHEME"
  (:use))

(defpackage "REVISED^4-SCHEME"
  (:use "LISP")
  (:export ".AND" "BEGIN" ".CASE" ".COND" "DEFINE" "DELAY" ".DO" ".IF"
	   ".LAMBDA" "LETREC" ".LET" ".LET*" ".OR" "QUASIQUOTE"
	   ".QUOTE" "SET!" "UNQUOTE" "UNQUOTE-SPLICING"
	   "DEFINE-SYNTAX" "LET-SYNTAX" "LETREC-SYNTAX" "SYNTAX-RULES"
	   "=>" "ELSE" ".*" ".+" ".-" "./" ".<" ".<=" ".=" ".>" ".>="
	   ".APPLY" "BOOLEAN?" "CALL-WITH-CURRENT-CONTINUATION" ".CAR"
	   ".CDR" "CHAR->INTEGER" "CHAR-READY?"  "CLOSE-INPUT-PORT"
	   "CLOSE-OUTPUT-PORT" "COMPLEX?" ".CONS" "CURRENT-INPUT-PORT"
	   "CURRENT-OUTPUT-PORT" ".DENOMINATOR" "EOF-OBJECT?" "EQ?"
	   "EQV?" "EXACT->INEXACT" "EXACT?"  "IMAG-PART"
	   "INEXACT->EXACT" "INEXACT?" "INPUT-PORT?" "INTEGER->CHAR"
	   "INTEGER?" ".LOAD" "MAGNITUDE" "MAKE-POLAR"
	   "MAKE-RECTANGULAR" ".MAKE-STRING" "MAKE-VECTOR" "MODULO"
	   "NEWLINE" ".NOT" "NULL?" "NUMBER?" ".NUMERATOR"
	   "OPEN-INPUT-FILE" "OPEN-OUTPUT-FILE" "OUTPUT-PORT?" "PAIR?"
	   ".PEEK-CHAR" "PROCEDURE?" "QUOTIENT" "RATIONAL?"
	   ".READ-CHAR" "REAL-PART" "REAL?" "REMAINDER" "SET-CAR!"
	   "SET-CDR!" ".STRING" "STRING->SYMBOL" "STRING-LENGTH"
	   "STRING-REF" "STRING-SET!" "STRING?" "SYMBOL->STRING"
	   "SYMBOL?"  "TRANSCRIPT-ON" "TRANSCRIPT-OFF" "VECTOR-LENGTH"
	   "VECTOR-REF" "VECTOR-SET!" "VECTOR?"  ".WRITE-CHAR"
	   ".APPEND" ".ASSOC" "ASSQ" "ASSV" ".ABS" ".ACOS" "ANGLE"
	   ".ASIN" ".ATAN" ".CAAAAR" ".CAAADR" ".CAADAR" ".CAADDR"
	   ".CAAAR" ".CAADR" ".CAAR" ".CADAAR" ".CADADR" ".CADDAR"
	   ".CADDDR" ".CADAR" ".CADDR" ".CADR" "CALL-WITH-INPUT-FILE"
	   "CALL-WITH-OUTPUT-FILE" ".CDAAAR" ".CDAADR" ".CDADAR"
	   ".CDADDR" ".CDAAR" ".CDADR" ".CDAR" ".CDDAAR" ".CDDADR"
	   ".CDDDAR" ".CDDDDR" ".CDDAR" ".CDDDR" ".CDDR" ".CEILING"
	   "CHAR-ALPHABETIC?" "CHAR-CI<=?" "CHAR-CI<?"  "CHAR-CI=?"
	   "CHAR-CI>=?" "CHAR-CI>?" ".CHAR-DOWNCASE"
	   "CHAR-LOWER-CASE?"  "CHAR-NUMERIC?" ".CHAR-UPCASE"
	   "CHAR-UPPER-CASE?" "CHAR-WHITESPACE?" "CHAR<=?" "CHAR<?"
	   "CHAR=?" "CHAR>=?" "CHAR>?" "CHAR?" ".COS" "DISPLAY"
	   "EQUAL?" "EVEN?" ".EXP" ".EXPT" ".FLOOR" "FOR-EACH" "FORCE"
	   ".GCD" ".LCM" ".LIST" ".LOG" ".LENGTH" "LIST->STRING"
	   "LIST->VECTOR" "LIST-REF" "LIST-TAIL" "LIST?" ".MAP" ".MAX"
	   ".MEMBER" "MEMQ" "MEMV" ".MIN" "NEGATIVE?"
	   "NUMBER->STRING" "ODD?" ".RATIONALIZE" "POSITIVE?" ".READ"
	   ".REVERSE" ".ROUND" ".SIN" ".SQRT" "STRING->LIST"
	   "STRING->NUMBER" "STRING-APPEND" "STRING-CI<=?"
	   "STRING-CI<?"  "STRING-CI=?" "STRING-CI>=?" "STRING-CI>?"
	   "STRING-COPY" "STRING-FILL!" "STRING<=?"  "STRING<?"
	   "STRING=?" "STRING>=?" "STRING>?" "SUBSTRING" ".TAN"
	   ".TRUNCATE" ".VECTOR" "VECTOR->LIST" "VECTOR-FILL!"
	   "WITH-INPUT-FROM-FILE" "WITH-OUTPUT-TO-FILE" ".WRITE"
	   "ZERO?"
	   ".VALUES" "CALL-WITH-VALUES" "DYNAMIC-WIND"))

(defpackage "SCHEME-TRANSLATOR"
  (:use "LISP" "REVISED^4-SCHEME")
  (:export "MAKE-PROGRAM-ENV"
           "MAKE-SIGNATURE"
	   "MAKE-MODULE"
	   "PROGRAM-ENV-ID"
	   "PROGRAM-ENV-PACKAGE"
	   "PROGRAM-ENV-LOOKUP"
	   "PROGRAM-ENV-DEFINE!"
	   "TRANSLATE"
	   "TRANSLATE-LAMBDA"
	   "REALLY-TRANSLATE-FILE"
	   "TRANSLATOR-VERSION"
	   "PERFORM-USUAL-INTEGRATIONS!"
	   "SCHEME-TRANSLATOR-ENV"
	   "SCHEME-TRANSLATOR-MODULE"
	   "REVISED^4-SCHEME-MODULE"
	   "SCHEME-USER-ENVIRONMENT"
	   ))

(defpackage "SCHH"
  (:nicknames "SCHEME-HACKS")
  (:use "LISP")
  (:export "INTERN-RENAMING-PERHAPS"
	   "QUALIFIED-SYMBOL-P"
	   "MAKE-PHOTON"
	   "PHOTON-P"
	   "FIND-SYMBOL-RENAMING-PERHAPS"
	   "LISP-PACKAGE"
	   "SCHEME-PACKAGE"
	   "SCHEME-READTABLE"
	   "*NON-SCHEME-READTABLE*"
	   "FIX-SCHEME-PACKAGE-IF-NECESSARY"
	   "CLEVER-LOAD"
	   "*SHARP-SHARP*"
	   ))

(defpackage "SCHI"
  (:nicknames "SCHEME-INTERNAL")
  (:use "LISP" "SCHEME-TRANSLATOR")
  (:import-from "SCHH" "LISP-PACKAGE")
  (:export "LOADIT"
	   "LISP-PACKAGE"
	   "SCHEME-USER-ENVIRONMENT"
	   "SCHEME-EVAL"
	   "SCHEME-LOAD"
	   "SCHEME-COMPILE"
	   "SCHEME-COMPILE-FILE"
	   "TRANSLATE-FILE"
	   "SET-REP-ENVIRONMENT!"
	   "SCHEME"
	   "QUIT"
	   "SCHEME-ERROR"
	   "PP"
	   ;; Auxiliaries for Scheme special forms & macros
	   "SET!-AUX"
	   "SET-FUNCTION-FROM-VALUE"
	   "SET-VALUE-FROM-FUNCTION"
	   "SET-FORWARDING-FUNCTION"
	   "UNSPECIFIED"
	   "UNASSIGNED"
	   "TRUE"			; #t
	   "FALSE"			; #f
	   "TRUE?"			; CL boolean -> Scheme boolean
	   "TRUEP"			; Scheme boolean -> CL boolean
	   "BEGIN-TRANSLATED-FILE"	;prelude
	   "AT-TOP-LEVEL"  		;kludge for symbolics lossage
	   ;; Additional auxiliaries for Revised^4 builtins
	   "SCHEME-PACKAGE"		;for STRING->SYMBOL
	   "PROCEDUREP"			;for PROCEDURE?
	   "SCHEME-SYMBOL-P"		;for SYMBOL?
	   "SCHEME-EQUAL-P"		;for MEMBER, ASSOC, EQUAL?
	   "BOOLEANP"
	   "CHAR-WHITESPACE-P"
	   "INPUT-PORT-P"
	   "OUTPUT-PORT-P"
	   "REALP"
	   ;; Additional auxiliaries for Revised^4 non-builtins
	   "SCHEME-LOAD"		;forward reference from RTS to EVAL
	   "SCHEME-READTABLE"		;for READ
	   "EOF-OBJECT"			;for READ, READ-CHAR
	   ;; Random
	   "SCHEME-ERROR"
	   ))
